JtdsDatabaseMetaData (jTDS API)
Keywords: net.sourceforge.jtds.jdbc.JtdsDatabaseMetaData class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sourceforge.jtds.jdbc
Class JtdsDatabaseMetaData

    java.lang.Object
      net.sourceforge.jtds.jdbc.JtdsDatabaseMetaData

All Implemented Interfaces:
  java.sql.DatabaseMetaData

public class JtdsDatabaseMetaData
extends java.lang.Object
implements java.sql.DatabaseMetaData

jTDS implementation of the java.sql.DatabaseMetaData interface.

Implementation note:

This is basically the code from the original jTDS driver. Main changes relate to the need to support the new ResultSet implementation.

TODO: Many of the system limits need to be revised to more accurately reflect the target database constraints. In many cases limits are soft and determined by bytes per column for example. Probably more of these functions should be altered to return 0 but for now the original jTDS values are returned.

Version:
  $Id: JtdsDatabaseMetaData.java,v 1.37.2.4 2009/12/30 08:45:34 ickzon Exp $
Author:
  Craig Spannring, The FreeTDS project, Alin Sinpalean created 17 March 2001

Field Summary
`(package private) java.lang.Boolean` | `caseSensitive` `Boolean.TRUE` if identifiers are case sensitive (the server was installed that way).
`private ConnectionJDBC2` | `connection`
`private int` | `serverType`
`(package private) static int` | `sqlStateXOpen`
`(package private) int` | `sysnameLength` Length of a sysname object (table name, catalog name etc.) -- 128 for TDS 7.0, 30 for earlier versions.
`private int` | `tdsVersion`

Fields inherited from interface java.sql.DatabaseMetaData
`attributeNoNulls, attributeNullable, attributeNullableUnknown, bestRowNotPseudo, bestRowPseudo, bestRowSession, bestRowTemporary, bestRowTransaction, bestRowUnknown, columnNoNulls, columnNullable, columnNullableUnknown, importedKeyCascade, importedKeyInitiallyDeferred, importedKeyInitiallyImmediate, importedKeyNoAction, importedKeyNotDeferrable, importedKeyRestrict, importedKeySetDefault, importedKeySetNull, procedureColumnIn, procedureColumnInOut, procedureColumnOut, procedureColumnResult, procedureColumnReturn, procedureColumnUnknown, procedureNoNulls, procedureNoResult, procedureNullable, procedureNullableUnknown, procedureResultUnknown, procedureReturnsResult, sqlStateSQL99, tableIndexClustered, tableIndexHashed, tableIndexOther, tableIndexStatistic, typeNoNulls, typeNullable, typeNullableUnknown, typePredBasic, typePredChar, typePredNone, typeSearchable, versionColumnNotPseudo, versionColumnPseudo, versionColumnUnknown`

Constructor Summary
`JtdsDatabaseMetaData(ConnectionJDBC2 connection)`

Method Summary
`boolean` | `allProceduresAreCallable()` Can all the procedures returned by getProcedures be called by the current user?
`boolean` | `allTablesAreSelectable()` Can all the tables returned by getTable be SELECTed by the current user?
`private static CachedResultSet` | `createTypeInfoResultSet(JtdsResultSet rs, boolean useLOBs)`
`boolean` | `dataDefinitionCausesTransactionCommit()` Does a data definition statement within a transaction force the transaction to commit?
`boolean` | `dataDefinitionIgnoredInTransactions()` Is a data definition statement within a transaction ignored?
`boolean` | `deletesAreDetected(int type)` JDBC 2.0 Indicates whether or not a visible row delete can be detected by calling ResultSet.rowDeleted().
`boolean` | `doesMaxRowSizeIncludeBlobs()` Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?
`java.sql.ResultSet` | `getAttributes(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String typeNamePattern, java.lang.String attributeNamePattern)`
`java.sql.ResultSet` | `getBestRowIdentifier(java.lang.String catalog, java.lang.String schema, java.lang.String table, int scope, boolean nullable)` Get a description of a table's optimal set of columns that uniquely identifies a row.
`java.sql.ResultSet` | `getCatalogs()` Get the catalog names available in this database.
`java.lang.String` | `getCatalogSeparator()` What's the separator between catalog and table name?
`java.lang.String` | `getCatalogTerm()` What's the database vendor's preferred term for "catalog"?
`java.sql.ResultSet` | `getColumnPrivileges(java.lang.String catalog, java.lang.String schema, java.lang.String table, java.lang.String columnNamePattern)` Get a description of the access rights for a table's columns.
`java.sql.ResultSet` | `getColumns(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern, java.lang.String columnNamePattern)` Get a description of table columns available in a catalog.
`java.sql.Connection` | `getConnection()` JDBC 2.0 Retrieves the connection that produced this metadata object.
`java.sql.ResultSet` | `getCrossReference(java.lang.String primaryCatalog, java.lang.String primarySchema, java.lang.String primaryTable, java.lang.String foreignCatalog, java.lang.String foreignSchema, java.lang.String foreignTable)` Get a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key).
`int` | `getDatabaseMajorVersion()` Returns the database major version.
`int` | `getDatabaseMinorVersion()` Returns the database minor version.
`java.lang.String` | `getDatabaseProductName()` Returns the name of this database product.
`java.lang.String` | `getDatabaseProductVersion()` Returns the version of this database product.
`int` | `getDefaultTransactionIsolation()` Returns the database's default transaction isolation level.
`int` | `getDriverMajorVersion()` Returns this JDBC driver's major version number.
`int` | `getDriverMinorVersion()` Returns this JDBC driver's minor version number.
`java.lang.String` | `getDriverName()` Returns the name of this JDBC driver.
`java.lang.String` | `getDriverVersion()` Returns the version of this JDBC driver.
`java.sql.ResultSet` | `getExportedKeys(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Get a description of the foreign key columns that reference a table's primary key columns (the foreign keys exported by a table).
`java.lang.String` | `getExtraNameCharacters()` Get all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).
`java.lang.String` | `getIdentifierQuoteString()` Returns the string used to quote SQL identifiers.
`java.sql.ResultSet` | `getImportedKeys(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Get a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table).
`java.sql.ResultSet` | `getIndexInfo(java.lang.String catalog, java.lang.String schema, java.lang.String table, boolean unique, boolean approximate)` Get a description of a table's indices and statistics.
`int` | `getJDBCMajorVersion()` Returns the JDBC major version.
`int` | `getJDBCMinorVersion()` Returns the JDBC minor version.
`int` | `getMaxBinaryLiteralLength()` How many hex characters can you have in an inline binary literal?
`int` | `getMaxCatalogNameLength()` What's the maximum length of a catalog name?
`int` | `getMaxCharLiteralLength()` What's the max length for a character literal?
`int` | `getMaxColumnNameLength()` What's the limit on column name length?
`int` | `getMaxColumnsInGroupBy()` What's the maximum number of columns in a "GROUP BY" clause?
`int` | `getMaxColumnsInIndex()` What's the maximum number of columns allowed in an index?
`int` | `getMaxColumnsInOrderBy()` What's the maximum number of columns in an "ORDER BY" clause?
`int` | `getMaxColumnsInSelect()` What's the maximum number of columns in a "SELECT" list?
`int` | `getMaxColumnsInTable()` What's the maximum number of columns in a table?
`int` | `getMaxConnections()` How many active connections can we have at a time to this database?
`int` | `getMaxCursorNameLength()` What's the maximum cursor name length?
`int` | `getMaxIndexLength()` What's the maximum length of an index (in bytes)?
`int` | `getMaxProcedureNameLength()` What's the maximum length of a procedure name?
`int` | `getMaxRowSize()` What's the maximum length of a single row?
`int` | `getMaxSchemaNameLength()` What's the maximum length allowed for a schema name?
`int` | `getMaxStatementLength()` What's the maximum length of a SQL statement?
`int` | `getMaxStatements()` How many active statements can we have open at one time to this database?
`int` | `getMaxTableNameLength()` What's the maximum length of a table name?
`int` | `getMaxTablesInSelect()` What's the maximum number of tables in a SELECT?
`int` | `getMaxUserNameLength()` What's the maximum length of a user name?
`java.lang.String` | `getNumericFunctions()` Get a comma separated list of math functions.
`java.sql.ResultSet` | `getPrimaryKeys(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Get a description of a table's primary key columns.
`java.sql.ResultSet` | `getProcedureColumns(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String procedureNamePattern, java.lang.String columnNamePattern)` Get a description of a catalog's stored procedure parameters and result columns.
`java.sql.ResultSet` | `getProcedures(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String procedureNamePattern)` Get a description of stored procedures available in a catalog.
`java.lang.String` | `getProcedureTerm()` What's the database vendor's preferred term for "procedure"?
`int` | `getResultSetHoldability()`
`java.sql.ResultSet` | `getSchemas()` Get the schema names available in this database.
`java.lang.String` | `getSchemaTerm()` What's the database vendor's preferred term for "schema"?
`java.lang.String` | `getSearchStringEscape()` This is the string that can be used to escape '_' or '%' in the string pattern style catalog search parameters.
`private static java.util.Collection` | `getSortedTypes(java.sql.ResultSet rs, boolean useLOBs)`
`java.lang.String` | `getSQLKeywords()` Get a comma separated list of all a database's SQL keywords that are NOT also SQL92 keywords.
`int` | `getSQLStateType()`
`java.lang.String` | `getStringFunctions()` Get a comma separated list of string functions.
`java.sql.ResultSet` | `getSuperTables(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern)`
`java.sql.ResultSet` | `getSuperTypes(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String typeNamePattern)`
`java.lang.String` | `getSystemFunctions()` Get a comma separated list of system functions.
`java.sql.ResultSet` | `getTablePrivileges(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern)` Get a description of the access rights for each table available in a catalog.
`java.sql.ResultSet` | `getTables(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String tableNamePattern, java.lang.String[] types)` Get a description of tables available in a catalog.
`java.sql.ResultSet` | `getTableTypes()` Get the table types available in this database.
`java.lang.String` | `getTimeDateFunctions()` Get a comma separated list of time and date functions.
`java.sql.ResultSet` | `getTypeInfo()` Get a description of all the standard SQL types supported by this database.
`java.sql.ResultSet` | `getUDTs(java.lang.String catalog, java.lang.String schemaPattern, java.lang.String typeNamePattern, int[] types)` JDBC 2.0 Gets a description of the user-defined types defined in a particular schema.
`java.lang.String` | `getURL()` What's the URL for this database?
`java.lang.String` | `getUserName()` What's our user name as known to the database?
`java.sql.ResultSet` | `getVersionColumns(java.lang.String catalog, java.lang.String schema, java.lang.String table)` Get a description of a table's columns that are automatically updated when any value in a row is updated.
`boolean` | `insertsAreDetected(int type)` JDBC 2.0 Indicates whether or not a visible row insert can be detected by calling ResultSet.rowInserted().
`boolean` | `isCatalogAtStart()` Retrieves whether a catalog appears at the start of a fully qualified table name.
`boolean` | `isReadOnly()` Is the database in read-only mode?
`boolean` | `locatorsUpdateCopy()` Returns `true` if updates are made to a copy of the LOB; returns `false` if LOB updates are made directly to the database.
`boolean` | `nullPlusNonNullIsNull()` Retrieves whether this database supports concatenations between `NULL` and non-`NULL` values being `NULL`.
`boolean` | `nullsAreSortedAtEnd()` Are NULL values sorted at the end regardless of sort order?
`boolean` | `nullsAreSortedAtStart()` Are NULL values sorted at the start regardless of sort order?
`boolean` | `nullsAreSortedHigh()` Are NULL values sorted high?
`boolean` | `nullsAreSortedLow()` Are NULL values sorted low?
`boolean` | `othersDeletesAreVisible(int type)` JDBC 2.0 Indicates whether deletes made by others are visible.
`boolean` | `othersInsertsAreVisible(int type)` JDBC 2.0 Indicates whether inserts made by others are visible.
`boolean` | `othersUpdatesAreVisible(int type)` JDBC 2.0 Indicates whether updates made by others are visible.
`boolean` | `ownDeletesAreVisible(int type)` JDBC 2.0 Indicates whether a result set's own deletes are visible.
`boolean` | `ownInsertsAreVisible(int type)` JDBC 2.0 Indicates whether a result set's own inserts are visible.
`boolean` | `ownUpdatesAreVisible(int type)` JDBC 2.0 Indicates whether a result set's own updates are visible.
`private static java.lang.String` | `processEscapes(java.lang.String pattern)` Format the supplied search pattern to transform the escape \x into [x].
`private void` | `setCaseSensitiveFlag()`
`boolean` | `storesLowerCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?
`boolean` | `storesLowerCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?
`boolean` | `storesMixedCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?
`boolean` | `storesMixedCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?
`boolean` | `storesUpperCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?
`boolean` | `storesUpperCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?
`boolean` | `supportsAlterTableWithAddColumn()` Is "ALTER TABLE" with add column supported?
`boolean` | `supportsAlterTableWithDropColumn()` Is "ALTER TABLE" with drop column supported?
`boolean` | `supportsANSI92EntryLevelSQL()` Retrieves whether this database supports the ANSI92 entry level SQL grammar.
`boolean` | `supportsANSI92FullSQL()` Is the ANSI92 full SQL grammar supported?
`boolean` | `supportsANSI92IntermediateSQL()` Is the ANSI92 intermediate SQL grammar supported?
`boolean` | `supportsBatchUpdates()` JDBC 2.0 Indicates whether the driver supports batch updates.
`boolean` | `supportsCatalogsInDataManipulation()` Can a catalog name be used in a data manipulation statement?
`boolean` | `supportsCatalogsInIndexDefinitions()` Can a catalog name be used in an index definition statement?
`boolean` | `supportsCatalogsInPrivilegeDefinitions()` Can a catalog name be used in a privilege definition statement?
`boolean` | `supportsCatalogsInProcedureCalls()` Can a catalog name be used in a procedure call statement?
`boolean` | `supportsCatalogsInTableDefinitions()` Can a catalog name be used in a table definition statement?
`boolean` | `supportsColumnAliasing()` Retrieves whether this database supports column aliasing.
`boolean` | `supportsConvert()` Is the CONVERT function between SQL types supported?
`boolean` | `supportsConvert(int fromType, int toType)` Is CONVERT between the given SQL types supported?
`boolean` | `supportsCoreSQLGrammar()` Is the ODBC Core SQL grammar supported?
`boolean` | `supportsCorrelatedSubqueries()` Retrieves whether this database supports correlated subqueries.
`boolean` | `supportsDataDefinitionAndDataManipulationTransactions()` Are both data definition and data manipulation statements within a transaction supported?
`boolean` | `supportsDataManipulationTransactionsOnly()` Are only data manipulation statements within a transaction supported?
`boolean` | `supportsDifferentTableCorrelationNames()` If table correlation names are supported, are they restricted to be different from the names of the tables?
`boolean` | `supportsExpressionsInOrderBy()` Are expressions in "ORDER BY" lists supported?
`boolean` | `supportsExtendedSQLGrammar()` Is the ODBC Extended SQL grammar supported?
`boolean` | `supportsFullOuterJoins()` Are full nested outer joins supported?
`boolean` | `supportsGetGeneratedKeys()` Returns `true` if getting auto-generated keys is supported after a statment is executed; returns `false` otherwise
`boolean` | `supportsGroupBy()` Is some form of "GROUP BY" clause supported?
`boolean` | `supportsGroupByBeyondSelect()` Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?
`boolean` | `supportsGroupByUnrelated()` Can a "GROUP BY" clause use columns not in the SELECT?
`boolean` | `supportsIntegrityEnhancementFacility()` Is the SQL Integrity Enhancement Facility supported?
`boolean` | `supportsLikeEscapeClause()` Retrieves whether this database supports specifying a `LIKE` escape clause.
`boolean` | `supportsLimitedOuterJoins()` Retrieves whether this database provides limited support for outer joins.
`boolean` | `supportsMinimumSQLGrammar()` Retrieves whether this database supports the ODBC Minimum SQL grammar.
`boolean` | `supportsMixedCaseIdentifiers()` Retrieves whether this database treats mixed case unquoted SQL identifiers as case sensitive and as a result stores them in mixed case.
`boolean` | `supportsMixedCaseQuotedIdentifiers()` Retrieves whether this database treats mixed case quoted SQL identifiers as case sensitive and as a result stores them in mixed case.
`boolean` | `supportsMultipleOpenResults()` Returns `true` if Callable statements can return multiple result sets; returns `false` if they can only return one result set.
`boolean` | `supportsMultipleResultSets()` Are multiple ResultSets from a single execute supported?
`boolean` | `supportsMultipleTransactions()` Can we have multiple transactions open at once (on different connections)?
`boolean` | `supportsNamedParameters()` Returns `true` if the database supports named parameters; returns `false` if the database does not support named parameters.
`boolean` | `supportsNonNullableColumns()` Retrieves whether columns in this database may be defined as non-nullable.
`boolean` | `supportsOpenCursorsAcrossCommit()` Can cursors remain open across commits?
`boolean` | `supportsOpenCursorsAcrossRollback()` Can cursors remain open across rollbacks?
`boolean` | `supportsOpenStatementsAcrossCommit()` Can statements remain open across commits?
`boolean` | `supportsOpenStatementsAcrossRollback()` Can statements remain open across rollbacks?
`boolean` | `supportsOrderByUnrelated()` Can an "ORDER BY" clause use columns not in the SELECT?
`boolean` | `supportsOuterJoins()` Is some form of outer join supported?
`boolean` | `supportsPositionedDelete()` Is positioned DELETE supported?
`boolean` | `supportsPositionedUpdate()` Is positioned UPDATE supported?
`boolean` | `supportsResultSetConcurrency(int type, int concurrency)` Does the database support the concurrency type in combination with the given result set type?
`boolean` | `supportsResultSetHoldability(int param)`
`boolean` | `supportsResultSetType(int type)` Does the database support the given result set type?
`boolean` | `supportsSavepoints()` Returns `true` if savepoints are supported; returns `false` otherwise
`boolean` | `supportsSchemasInDataManipulation()` Can a schema name be used in a data manipulation statement?
`boolean` | `supportsSchemasInIndexDefinitions()` Can a schema name be used in an index definition statement?
`boolean` | `supportsSchemasInPrivilegeDefinitions()` Can a schema name be used in a privilege definition statement?
`boolean` | `supportsSchemasInProcedureCalls()` Can a schema name be used in a procedure call statement?
`boolean` | `supportsSchemasInTableDefinitions()` Can a schema name be used in a table definition statement?
`boolean` | `supportsSelectForUpdate()` Is SELECT for UPDATE supported?
`boolean` | `supportsStatementPooling()` Returns `true` if the database supports statement pooling; returns `false` otherwise.
`boolean` | `supportsStoredProcedures()` Are stored procedure calls using the stored procedure escape syntax supported?
`boolean` | `supportsSubqueriesInComparisons()` Retrieves whether this database supports subqueries in comparison expressions.
`boolean` | `supportsSubqueriesInExists()` Retrieves whether this database supports subqueries in `EXISTS` expressions.
`boolean` | `supportsSubqueriesInIns()` Retrieves whether this database supports subqueries in `IN` statements.
`boolean` | `supportsSubqueriesInQuantifieds()` Retrieves whether this database supports subqueries in quantified expressions.
`boolean` | `supportsTableCorrelationNames()` Retrieves whether this database supports table correlation names.
`boolean` | `supportsTransactionIsolationLevel(int level)` Does the database support the given transaction isolation level?
`boolean` | `supportsTransactions()` Retrieves whether this database supports transactions.
`boolean` | `supportsUnion()` Is SQL UNION supported?
`boolean` | `supportsUnionAll()` Is SQL UNION ALL supported?
`private java.lang.String` | `syscall(java.lang.String catalog, java.lang.String call)` Format the supplied procedure call as a valid JDBC call escape.
`boolean` | `updatesAreDetected(int type)` JDBC 2.0 Indicates whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated` .
`private static void` | `upperCaseColumnNames(JtdsResultSet results)` Uppercase all column names.
`boolean` | `usesLocalFilePerTable()` Does the database use a file for each table?
`boolean` | `usesLocalFiles()` Does the database store tables in a local file?

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### sqlStateXOpen

    static final int sqlStateXOpen

See Also:
  Constant Field Values

### tdsVersion

    private final int tdsVersion

### serverType

    private final int serverType

### connection

    private final ConnectionJDBC2 connection

### sysnameLength

    int sysnameLength

  Length of a sysname object (table name, catalog name etc.) -- 128 for TDS 7.0, 30 for earlier versions.

### caseSensitive

    java.lang.Boolean caseSensitive

  `Boolean.TRUE` if identifiers are case sensitive (the server was installed that way). Initially `null`, set the first time any of the methods that check this are called.

Constructor Detail

### JtdsDatabaseMetaData

    public JtdsDatabaseMetaData(ConnectionJDBC2 connection)

Method Detail

### allProceduresAreCallable

    public boolean allProceduresAreCallable()
                                     throws java.sql.SQLException

  Can all the procedures returned by getProcedures be called by the current user?

  Specified by:
    `allProceduresAreCallable` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### allTablesAreSelectable

    public boolean allTablesAreSelectable()
                                   throws java.sql.SQLException

  Can all the tables returned by getTable be SELECTed by the current user?

  Specified by:
    `allTablesAreSelectable` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### dataDefinitionCausesTransactionCommit

    public boolean dataDefinitionCausesTransactionCommit()
                                                  throws java.sql.SQLException

  Does a data definition statement within a transaction force the transaction to commit?

  Specified by:
    `dataDefinitionCausesTransactionCommit` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### dataDefinitionIgnoredInTransactions

    public boolean dataDefinitionIgnoredInTransactions()
                                                throws java.sql.SQLException

  Is a data definition statement within a transaction ignored?

  Specified by:
    `dataDefinitionIgnoredInTransactions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### doesMaxRowSizeIncludeBlobs

    public boolean doesMaxRowSizeIncludeBlobs()
                                       throws java.sql.SQLException

  Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?

  Specified by:
    `doesMaxRowSizeIncludeBlobs` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getBestRowIdentifier

    public java.sql.ResultSet getBestRowIdentifier(java.lang.String catalog,
                                                   java.lang.String schema,
                                                   java.lang.String table,
                                                   int scope,
                                                   boolean nullable)
                                            throws java.sql.SQLException

  Get a description of a table's optimal set of columns that uniquely identifies a row. They are ordered by SCOPE.

  Each column description has the following columns:

  1. SCOPE short =>actual scope of result
     - bestRowTemporary - very temporary, while using row
     - bestRowTransaction - valid for remainder of current transaction
     - bestRowSession - valid for remainder of current session
  2. COLUMN_NAME String =>column name
  3. DATA_TYPE short =>SQL data type from java.sql.Types
  4. TYPE_NAME String =>Data source dependent type name
  5. COLUMN_SIZE int =>precision
  6. BUFFER_LENGTH int =>not used
  7. DECIMAL_DIGITS short =>scale
  8. PSEUDO_COLUMN short =>is this a pseudo column like an Oracle ROWID
     - bestRowUnknown - may or may not be pseudo column
     - bestRowNotPseudo - is NOT a pseudo column
     - bestRowPseudo - is a pseudo column

  Specified by:
    `getBestRowIdentifier` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
    `scope` - the scope of interest; use same values as SCOPE
    `nullable` - include columns that are nullable?
  Returns:
    ResultSet - each row is a column description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getCatalogs

    public java.sql.ResultSet getCatalogs()
                                   throws java.sql.SQLException

  Get the catalog names available in this database. The results are ordered by catalog name.

  The catalog column is:

  1. TABLE_CAT String =>catalog name

  Specified by:
    `getCatalogs` in interface `java.sql.DatabaseMetaData`
  Returns:
    ResultSet - each row has a single String column that is a catalog name
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getCatalogSeparator

    public java.lang.String getCatalogSeparator()
                                         throws java.sql.SQLException

  What's the separator between catalog and table name?

  Specified by:
    `getCatalogSeparator` in interface `java.sql.DatabaseMetaData`
  Returns:
    the separator string
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getCatalogTerm

    public java.lang.String getCatalogTerm()
                                    throws java.sql.SQLException

  What's the database vendor's preferred term for "catalog"?

  Specified by:
    `getCatalogTerm` in interface `java.sql.DatabaseMetaData`
  Returns:
    the vendor term
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getColumnPrivileges

    public java.sql.ResultSet getColumnPrivileges(java.lang.String catalog,
                                                  java.lang.String schema,
                                                  java.lang.String table,
                                                  java.lang.String columnNamePattern)
                                           throws java.sql.SQLException

  Get a description of the access rights for a table's columns.

  Only privileges matching the column name criteria are returned. They are ordered by COLUMN_NAME and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String =>table catalog (may be null)
  2. TABLE_SCHEM String =>table schema (may be null)
  3. TABLE_NAME String =>table name
  4. COLUMN_NAME String =>column name
  5. GRANTOR =>grantor of access (may be null)
  6. GRANTEE String =>grantee of access
  7. PRIVILEGE String =>name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  8. IS_GRANTABLE String =>"YES" if grantee is permitted to grant to others; "NO" if not; null if unknown

  Specified by:
    `getColumnPrivileges` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema schema
    `table` - a table name
    `columnNamePattern` - a column name pattern
  Returns:
    ResultSet - each row is a column privilege description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.
  See Also:
    `getSearchStringEscape()`

### getColumns

    public java.sql.ResultSet getColumns(java.lang.String catalog,
                                         java.lang.String schemaPattern,
                                         java.lang.String tableNamePattern,
                                         java.lang.String columnNamePattern)
                                  throws java.sql.SQLException

  Get a description of table columns available in a catalog.

  Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME and ORDINAL_POSITION.

  Each column description has the following columns:

  1. TABLE_CAT String =>table catalog (may be null)
  2. TABLE_SCHEM String =>table schema (may be null)
  3. TABLE_NAME String =>table name
  4. COLUMN_NAME String =>column name
  5. DATA_TYPE short =>SQL type from java.sql.Types
  6. TYPE_NAME String =>Data source dependent type name
  7. COLUMN_SIZE int =>column size. For char or date types this is the maximum number of characters, for numeric or decimal types this is precision.
  8. BUFFER_LENGTH is not used.
  9. DECIMAL_DIGITS int =>the number of fractional digits
  10. NUM_PREC_RADIX int =>Radix (typically either 10 or 2)
  11. NULLABLE int =>is NULL allowed?
      - columnNoNulls - might not allow NULL values
      - columnNullable - definitely allows NULL values
      - columnNullableUnknown - nullability unknown
  12. REMARKS String =>comment describing column (may be null)
  13. COLUMN_DEF String =>default value (may be null)
  14. SQL_DATA_TYPE int =>unused
  15. SQL_DATETIME_SUB int =>unused
  16. CHAR_OCTET_LENGTH int =>for char types the maximum number of bytes in the column
  17. ORDINAL_POSITION int =>index of column in table (starting at 1)
  18. IS_NULLABLE String =>"NO" means column definitely does not allow NULL values; "YES" means the column might allow NULL values. An empty string means nobody knows.

  Specified by:
    `getColumns` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
    `columnNamePattern` - a column name pattern
  Returns:
    ResultSet - each row is a column description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.
  See Also:
    `getSearchStringEscape()`

### getCrossReference

    public java.sql.ResultSet getCrossReference(java.lang.String primaryCatalog,
                                                java.lang.String primarySchema,
                                                java.lang.String primaryTable,
                                                java.lang.String foreignCatalog,
                                                java.lang.String foreignSchema,
                                                java.lang.String foreignTable)
                                         throws java.sql.SQLException

  Get a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key). This should normally return a single foreign key/primary key pair (most tables only import a foreign key from a table once.) They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String =>primary key table catalog (may be null)
  2. PKTABLE_SCHEM String =>primary key table schema (may be null)
  3. PKTABLE_NAME String =>primary key table name
  4. PKCOLUMN_NAME String =>primary key column name
  5. FKTABLE_CAT String =>foreign key table catalog (may be null) being exported (may be null)
  6. FKTABLE_SCHEM String =>foreign key table schema (may be null) being exported (may be null)
  7. FKTABLE_NAME String =>foreign key table name being exported
  8. FKCOLUMN_NAME String =>foreign key column name being exported
  9. KEY_SEQ short =>sequence number within foreign key
  10. UPDATE_RULE short =>What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short =>What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String =>foreign key name (may be null)
  13. PK_NAME String =>primary key name (may be null)
  14. DEFERRABILITY short =>can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  Specified by:
    `getCrossReference` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `primaryCatalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `primarySchema` - a schema name pattern; "" retrieves those without a schema
    `primaryTable` - the table name that exports the key
    `foreignCatalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `foreignSchema` - a schema name pattern; "" retrieves those without a schema
    `foreignTable` - the table name that imports the key
  Returns:
    ResultSet - each row is a foreign key column description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getDatabaseProductName

    public java.lang.String getDatabaseProductName()
                                            throws java.sql.SQLException

  Returns the name of this database product.

  Specified by:
    `getDatabaseProductName` in interface `java.sql.DatabaseMetaData`
  Returns:
    database product name
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getDatabaseProductVersion

    public java.lang.String getDatabaseProductVersion()
                                               throws java.sql.SQLException

  Returns the version of this database product.

  Specified by:
    `getDatabaseProductVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    database version
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getDefaultTransactionIsolation

    public int getDefaultTransactionIsolation()
                                       throws java.sql.SQLException

  Returns the database's default transaction isolation level. The values are defined in java.sql.Connection.

  Specified by:
    `getDefaultTransactionIsolation` in interface `java.sql.DatabaseMetaData`
  Returns:
    the default isolation level
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.
  See Also:
    `Connection`

### getDriverMajorVersion

    public int getDriverMajorVersion()

  Returns this JDBC driver's major version number.

  Specified by:
    `getDriverMajorVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    JDBC driver major version

### getDriverMinorVersion

    public int getDriverMinorVersion()

  Returns this JDBC driver's minor version number.

  Specified by:
    `getDriverMinorVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    JDBC driver minor version number

### getDriverName

    public java.lang.String getDriverName()
                                   throws java.sql.SQLException

  Returns the name of this JDBC driver.

  Specified by:
    `getDriverName` in interface `java.sql.DatabaseMetaData`
  Returns:
    JDBC driver name
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getDriverVersion

    public java.lang.String getDriverVersion()
                                      throws java.sql.SQLException

  Returns the version of this JDBC driver.

  Specified by:
    `getDriverVersion` in interface `java.sql.DatabaseMetaData`
  Returns:
    JDBC driver version
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getExportedKeys

    public java.sql.ResultSet getExportedKeys(java.lang.String catalog,
                                              java.lang.String schema,
                                              java.lang.String table)
                                       throws java.sql.SQLException

  Get a description of the foreign key columns that reference a table's primary key columns (the foreign keys exported by a table). They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String =>primary key table catalog (may be null)
  2. PKTABLE_SCHEM String =>primary key table schema (may be null)
  3. PKTABLE_NAME String =>primary key table name
  4. PKCOLUMN_NAME String =>primary key column name
  5. FKTABLE_CAT String =>foreign key table catalog (may be null) being exported (may be null)
  6. FKTABLE_SCHEM String =>foreign key table schema (may be null) being exported (may be null)
  7. FKTABLE_NAME String =>foreign key table name being exported
  8. FKCOLUMN_NAME String =>foreign key column name being exported
  9. KEY_SEQ short =>sequence number within foreign key
  10. UPDATE_RULE short =>What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short =>What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String =>foreign key name (may be null)
  13. PK_NAME String =>primary key name (may be null)
  14. DEFERRABILITY short =>can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  Specified by:
    `getExportedKeys` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    ResultSet - each row is a foreign key column description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getExtraNameCharacters

    public java.lang.String getExtraNameCharacters()
                                            throws java.sql.SQLException

  Get all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).

  Specified by:
    `getExtraNameCharacters` in interface `java.sql.DatabaseMetaData`
  Returns:
    the string containing the extra characters
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getIdentifierQuoteString

    public java.lang.String getIdentifierQuoteString()
                                              throws java.sql.SQLException

  Returns the string used to quote SQL identifiers. This returns a space " " if identifier quoting isn't supported. A JDBC-Compliant driver always uses a double quote character.

  Specified by:
    `getIdentifierQuoteString` in interface `java.sql.DatabaseMetaData`
  Returns:
    the quoting string
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getImportedKeys

    public java.sql.ResultSet getImportedKeys(java.lang.String catalog,
                                              java.lang.String schema,
                                              java.lang.String table)
                                       throws java.sql.SQLException

  Get a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table). They are ordered by PKTABLE_CAT, PKTABLE_SCHEM, PKTABLE_NAME, and KEY_SEQ.

  Each primary key column description has the following columns:

  1. PKTABLE_CAT String =>primary key table catalog being imported (may be null)
  2. PKTABLE_SCHEM String =>primary key table schema being imported (may be null)
  3. PKTABLE_NAME String =>primary key table name being imported
  4. PKCOLUMN_NAME String =>primary key column name being imported
  5. FKTABLE_CAT String =>foreign key table catalog (may be null)
  6. FKTABLE_SCHEM String =>foreign key table schema (may be null)
  7. FKTABLE_NAME String =>foreign key table name
  8. FKCOLUMN_NAME String =>foreign key column name
  9. KEY_SEQ short =>sequence number within foreign key
  10. UPDATE_RULE short =>What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short =>What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String =>foreign key name (may be null)
  13. PK_NAME String =>primary key name (may be null)
  14. DEFERRABILITY short =>can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  Specified by:
    `getImportedKeys` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    ResultSet - each row is a primary key column description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.
  See Also:
    `getExportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getIndexInfo

    public java.sql.ResultSet getIndexInfo(java.lang.String catalog,
                                           java.lang.String schema,
                                           java.lang.String table,
                                           boolean unique,
                                           boolean approximate)
                                    throws java.sql.SQLException

  Get a description of a table's indices and statistics. They are ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.

  Each index column description has the following columns:

  1. TABLE_CAT String =>table catalog (may be null)
  2. TABLE_SCHEM String =>table schema (may be null)
  3. TABLE_NAME String =>table name
  4. NON_UNIQUE boolean =>Can index values be non-unique? false when TYPE is tableIndexStatistic
  5. INDEX_QUALIFIER String =>index catalog (may be null); null when TYPE is tableIndexStatistic
  6. INDEX_NAME String =>index name; null when TYPE is tableIndexStatistic
  7. TYPE short =>index type:
     - tableIndexStatistic - this identifies table statistics that are returned in conjuction with a table's index descriptions
     - tableIndexClustered - this is a clustered index
     - tableIndexHashed - this is a hashed index
     - tableIndexOther - this is some other style of index
  8. ORDINAL_POSITION short =>column sequence number within index; zero when TYPE is tableIndexStatistic
  9. COLUMN_NAME String =>column name; null when TYPE is tableIndexStatistic
  10. ASC_OR_DESC String =>column sort sequence, "A" => ascending, "D" =>descending, may be null if sort sequence is not supported; null when TYPE is tableIndexStatistic
  11. CARDINALITY int =>When TYPE is tableIndexStatistic, then this is the number of rows in the table; otherwise, it is the number of unique values in the index.
  12. PAGES int =>When TYPE is tableIndexStatisic then this is the number of pages used for the table, otherwise it is the number of pages used for the current index.
  13. FILTER_CONDITION String =>Filter condition, if any. (may be null)

  Specified by:
    `getIndexInfo` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
    `unique` - when `true`, return only indices for unique values; when `false`, return indices regardless of whether unique or not
    `approximate` - when `true`, result is allowed to reflect approximate or out of data values; when `false`, results are requested to be accurate
  Returns:
    ResultSet - each row is an index column description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxBinaryLiteralLength

    public int getMaxBinaryLiteralLength()
                                  throws java.sql.SQLException

  How many hex characters can you have in an inline binary literal?

  Specified by:
    `getMaxBinaryLiteralLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max literal length
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxCatalogNameLength

    public int getMaxCatalogNameLength()
                                throws java.sql.SQLException

  What's the maximum length of a catalog name?

  Specified by:
    `getMaxCatalogNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max name length in bytes
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxCharLiteralLength

    public int getMaxCharLiteralLength()
                                throws java.sql.SQLException

  What's the max length for a character literal?

  Specified by:
    `getMaxCharLiteralLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max literal length
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxColumnNameLength

    public int getMaxColumnNameLength()
                               throws java.sql.SQLException

  What's the limit on column name length?

  Specified by:
    `getMaxColumnNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max literal length
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxColumnsInGroupBy

    public int getMaxColumnsInGroupBy()
                               throws java.sql.SQLException

  What's the maximum number of columns in a "GROUP BY" clause?

  Specified by:
    `getMaxColumnsInGroupBy` in interface `java.sql.DatabaseMetaData`
  Returns:
    max number of columns
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxColumnsInIndex

    public int getMaxColumnsInIndex()
                             throws java.sql.SQLException

  What's the maximum number of columns allowed in an index?

  Specified by:
    `getMaxColumnsInIndex` in interface `java.sql.DatabaseMetaData`
  Returns:
    max columns
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxColumnsInOrderBy

    public int getMaxColumnsInOrderBy()
                               throws java.sql.SQLException

  What's the maximum number of columns in an "ORDER BY" clause?

  Specified by:
    `getMaxColumnsInOrderBy` in interface `java.sql.DatabaseMetaData`
  Returns:
    max columns
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxColumnsInSelect

    public int getMaxColumnsInSelect()
                              throws java.sql.SQLException

  What's the maximum number of columns in a "SELECT" list?

  Specified by:
    `getMaxColumnsInSelect` in interface `java.sql.DatabaseMetaData`
  Returns:
    max columns
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxColumnsInTable

    public int getMaxColumnsInTable()
                             throws java.sql.SQLException

  What's the maximum number of columns in a table?

  Specified by:
    `getMaxColumnsInTable` in interface `java.sql.DatabaseMetaData`
  Returns:
    max columns
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxConnections

    public int getMaxConnections()
                          throws java.sql.SQLException

  How many active connections can we have at a time to this database?

  Specified by:
    `getMaxConnections` in interface `java.sql.DatabaseMetaData`
  Returns:
    max connections
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxCursorNameLength

    public int getMaxCursorNameLength()
                               throws java.sql.SQLException

  What's the maximum cursor name length?

  Specified by:
    `getMaxCursorNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max cursor name length in bytes
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxIndexLength

    public int getMaxIndexLength()
                          throws java.sql.SQLException

  What's the maximum length of an index (in bytes)?

  Specified by:
    `getMaxIndexLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max index length in bytes
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxProcedureNameLength

    public int getMaxProcedureNameLength()
                                  throws java.sql.SQLException

  What's the maximum length of a procedure name?

  Specified by:
    `getMaxProcedureNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max name length in bytes
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxRowSize

    public int getMaxRowSize()
                      throws java.sql.SQLException

  What's the maximum length of a single row?

  Specified by:
    `getMaxRowSize` in interface `java.sql.DatabaseMetaData`
  Returns:
    max row size in bytes
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxSchemaNameLength

    public int getMaxSchemaNameLength()
                               throws java.sql.SQLException

  What's the maximum length allowed for a schema name?

  Specified by:
    `getMaxSchemaNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max name length in bytes
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxStatementLength

    public int getMaxStatementLength()
                              throws java.sql.SQLException

  What's the maximum length of a SQL statement?

  Specified by:
    `getMaxStatementLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max length in bytes
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxStatements

    public int getMaxStatements()
                         throws java.sql.SQLException

  How many active statements can we have open at one time to this database?

  Specified by:
    `getMaxStatements` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxTableNameLength

    public int getMaxTableNameLength()
                              throws java.sql.SQLException

  What's the maximum length of a table name?

  Specified by:
    `getMaxTableNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max name length in bytes
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxTablesInSelect

    public int getMaxTablesInSelect()
                             throws java.sql.SQLException

  What's the maximum number of tables in a SELECT?

  Specified by:
    `getMaxTablesInSelect` in interface `java.sql.DatabaseMetaData`
  Returns:
    the maximum
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getMaxUserNameLength

    public int getMaxUserNameLength()
                             throws java.sql.SQLException

  What's the maximum length of a user name?

  Specified by:
    `getMaxUserNameLength` in interface `java.sql.DatabaseMetaData`
  Returns:
    max name length in bytes
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getNumericFunctions

    public java.lang.String getNumericFunctions()
                                         throws java.sql.SQLException

  Get a comma separated list of math functions.

  Specified by:
    `getNumericFunctions` in interface `java.sql.DatabaseMetaData`
  Returns:
    the list
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getPrimaryKeys

    public java.sql.ResultSet getPrimaryKeys(java.lang.String catalog,
                                             java.lang.String schema,
                                             java.lang.String table)
                                      throws java.sql.SQLException

  Get a description of a table's primary key columns. They are ordered by COLUMN_NAME.

  Each primary key column description has the following columns:

  1. TABLE_CAT String =>table catalog (may be null)
  2. TABLE_SCHEM String =>table schema (may be null)
  3. TABLE_NAME String =>table name
  4. COLUMN_NAME String =>column name
  5. KEY_SEQ short =>sequence number within primary key
  6. PK_NAME String =>primary key name (may be null)

  Specified by:
    `getPrimaryKeys` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    ResultSet - each row is a primary key column description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getProcedureColumns

    public java.sql.ResultSet getProcedureColumns(java.lang.String catalog,
                                                  java.lang.String schemaPattern,
                                                  java.lang.String procedureNamePattern,
                                                  java.lang.String columnNamePattern)
                                           throws java.sql.SQLException

  Get a description of a catalog's stored procedure parameters and result columns.

  Only descriptions matching the schema, procedure and parameter name criteria are returned. They are ordered by PROCEDURE_SCHEM and PROCEDURE_NAME. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

  Each row in the ResultSet is a parameter description or column description with the following fields:

  1. PROCEDURE_CAT String =>procedure catalog (may be null)
  2. PROCEDURE_SCHEM String =>procedure schema (may be null)
  3. PROCEDURE_NAME String =>procedure name
  4. COLUMN_NAME String =>column/parameter name
  5. COLUMN_TYPE Short =>kind of column/parameter:
     - procedureColumnUnknown - nobody knows
     - procedureColumnIn - IN parameter
     - procedureColumnInOut - INOUT parameter
     - procedureColumnOut - OUT parameter
     - procedureColumnReturn - procedure return value
     - procedureColumnResult - result column in ResultSet
  6. DATA_TYPE short =>SQL type from java.sql.Types
  7. TYPE_NAME String =>SQL type name
  8. PRECISION int =>precision
  9. LENGTH int =>length in bytes of data
  10. SCALE short =>scale
  11. RADIX short =>radix
  12. NULLABLE short =>can it contain NULL?
      - procedureNoNulls - does not allow NULL values
      - procedureNullable - allows NULL values
      - procedureNullableUnknown - nullability unknown
  13. REMARKS String =>comment describing parameter/column

  Note: Some databases may not return the column descriptions for a procedure. Additional columns beyond REMARKS can be defined by the database.

  Specified by:
    `getProcedureColumns` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `procedureNamePattern` - a procedure name pattern
    `columnNamePattern` - a column name pattern
  Returns:
    ResultSet - each row is a stored procedure parameter or column description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.
  See Also:
    `getSearchStringEscape()`

### getProcedures

    public java.sql.ResultSet getProcedures(java.lang.String catalog,
                                            java.lang.String schemaPattern,
                                            java.lang.String procedureNamePattern)
                                     throws java.sql.SQLException

  Get a description of stored procedures available in a catalog.

  Only procedure descriptions matching the schema and procedure name criteria are returned. They are ordered by PROCEDURE_SCHEM, and PROCEDURE_NAME.

  Each procedure description has the the following columns:

  1. PROCEDURE_CAT String =>procedure catalog (may be null)
  2. PROCEDURE_SCHEM String =>procedure schema (may be null)
  3. PROCEDURE_NAME String =>procedure name
  4. reserved for future use
  5. reserved for future use
  6. reserved for future use
  7. REMARKS String =>explanatory comment on the procedure
  8. PROCEDURE_TYPE short =>kind of procedure:
     - procedureResultUnknown - May return a result
     - procedureNoResult - Does not return a result
     - procedureReturnsResult - Returns a result

  Specified by:
    `getProcedures` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `procedureNamePattern` - a procedure name pattern
  Returns:
    ResultSet - each row is a procedure description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.
  See Also:
    `getSearchStringEscape()`

### getProcedureTerm

    public java.lang.String getProcedureTerm()
                                      throws java.sql.SQLException

  What's the database vendor's preferred term for "procedure"?

  Specified by:
    `getProcedureTerm` in interface `java.sql.DatabaseMetaData`
  Returns:
    the vendor term
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getSchemas

    public java.sql.ResultSet getSchemas()
                                  throws java.sql.SQLException

  Get the schema names available in this database. The results are ordered by schema name.

  The schema column is:

  1. TABLE_SCHEM String => schema name
  2. TABLE_CATALOG String => catalog name (may be `null`, JDBC 3.0)

  Specified by:
    `getSchemas` in interface `java.sql.DatabaseMetaData`
  Returns:
    a `ResultSet` object in which each row is a schema description
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getSchemaTerm

    public java.lang.String getSchemaTerm()
                                   throws java.sql.SQLException

  What's the database vendor's preferred term for "schema"?

  Specified by:
    `getSchemaTerm` in interface `java.sql.DatabaseMetaData`
  Returns:
    the vendor term
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getSearchStringEscape

    public java.lang.String getSearchStringEscape()
                                           throws java.sql.SQLException

  This is the string that can be used to escape '_' or '%' in the string pattern style catalog search parameters.

  The '_' character represents any single character.

  The '%' character represents any sequence of zero or more characters.

  Specified by:
    `getSearchStringEscape` in interface `java.sql.DatabaseMetaData`
  Returns:
    the string used to escape wildcard characters
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getSQLKeywords

    public java.lang.String getSQLKeywords()
                                    throws java.sql.SQLException

  Get a comma separated list of all a database's SQL keywords that are NOT also SQL92 keywords.

  Specified by:
    `getSQLKeywords` in interface `java.sql.DatabaseMetaData`
  Returns:
    the list
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getStringFunctions

    public java.lang.String getStringFunctions()
                                        throws java.sql.SQLException

  Get a comma separated list of string functions.

  Specified by:
    `getStringFunctions` in interface `java.sql.DatabaseMetaData`
  Returns:
    the list
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getSystemFunctions

    public java.lang.String getSystemFunctions()
                                        throws java.sql.SQLException

  Get a comma separated list of system functions.

  Specified by:
    `getSystemFunctions` in interface `java.sql.DatabaseMetaData`
  Returns:
    the list
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getTablePrivileges

    public java.sql.ResultSet getTablePrivileges(java.lang.String catalog,
                                                 java.lang.String schemaPattern,
                                                 java.lang.String tableNamePattern)
                                          throws java.sql.SQLException

  Get a description of the access rights for each table available in a catalog. Note that a table privilege applies to one or more columns in the table. It would be wrong to assume that this priviledge applies to all columns (this may be true for some systems but is not true for all.)

  Only privileges matching the schema and table name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME, and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String =>table catalog (may be null)
  2. TABLE_SCHEM String =>table schema (may be null)
  3. TABLE_NAME String =>table name
  4. GRANTOR =>grantor of access (may be null)
  5. GRANTEE String =>grantee of access
  6. PRIVILEGE String =>name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  7. IS_GRANTABLE String =>"YES" if grantee is permitted to grant to others; "NO" if not; null if unknown

  Specified by:
    `getTablePrivileges` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
  Returns:
    ResultSet - each row is a table privilege description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.
  See Also:
    `getSearchStringEscape()`

### getTables

    public java.sql.ResultSet getTables(java.lang.String catalog,
                                        java.lang.String schemaPattern,
                                        java.lang.String tableNamePattern,
                                        java.lang.String[] types)
                                 throws java.sql.SQLException

  Get a description of tables available in a catalog.

  Only table descriptions matching the catalog, schema, table name and type criteria are returned. They are ordered by TABLE_TYPE, TABLE_SCHEM and TABLE_NAME.

  Each table description has the following columns:

  1. TABLE_CAT String =>table catalog (may be null)
  2. TABLE_SCHEM String =>table schema (may be null)
  3. TABLE_NAME String =>table name
  4. TABLE_TYPE String =>table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
  5. REMARKS String =>explanatory comment on the table
  6. TYPE_CAT String => the types catalog (may be `null`)
  7. TYPE_SCHEM String => the types schema (may be `null`)
  8. TYPE_NAME String => type name (may be `null`)
  9. SELF_REFERENCING_COL_NAME String => name of the designated "identifier" column of a typed table (may be `null`)
  10. REF_GENERATION String => specifies how values in SELF_REFERENCING_COL_NAME are created. Values are "SYSTEM", "USER", "DERIVED". (may be `null`)

  Note: Some databases may not return information for all tables.

  Specified by:
    `getTables` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
    `types` - a list of table types to include; null returns all types
  Returns:
    ResultSet - each row is a table description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.
  See Also:
    `getSearchStringEscape()`

### getTableTypes

    public java.sql.ResultSet getTableTypes()
                                     throws java.sql.SQLException

  Get the table types available in this database. The results are ordered by table type.

  The table type is:

  1. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".

  Specified by:
    `getTableTypes` in interface `java.sql.DatabaseMetaData`
  Returns:
    ResultSet - each row has a single String column that is a table type
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getTimeDateFunctions

    public java.lang.String getTimeDateFunctions()
                                          throws java.sql.SQLException

  Get a comma separated list of time and date functions.

  Specified by:
    `getTimeDateFunctions` in interface `java.sql.DatabaseMetaData`
  Returns:
    the list
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getTypeInfo

    public java.sql.ResultSet getTypeInfo()
                                   throws java.sql.SQLException

  Get a description of all the standard SQL types supported by this database. They are ordered by DATA_TYPE and then by how closely the data type maps to the corresponding JDBC SQL type.

  Each type description has the following columns:

  1. TYPE_NAME String =>Type name
  2. DATA_TYPE short =>SQL data type from java.sql.Types
  3. PRECISION int =>maximum precision
  4. LITERAL_PREFIX String =>prefix used to quote a literal (may be null)
  5. LITERAL_SUFFIX String =>suffix used to quote a literal (may be null)
  6. CREATE_PARAMS String =>parameters used in creating the type (may be null)
  7. NULLABLE short =>can you use NULL for this type?
     - typeNoNulls - does not allow NULL values
     - typeNullable - allows NULL values
     - typeNullableUnknown - nullability unknown
  8. CASE_SENSITIVE boolean=>is it case sensitive?
  9. SEARCHABLE short =>can you use "WHERE" based on this type:
     - typePredNone - No support
     - typePredChar - Only supported with WHERE .. LIKE
     - typePredBasic - Supported except for WHERE .. LIKE
     - typeSearchable - Supported for all WHERE ..
  10. UNSIGNED_ATTRIBUTE boolean =>is it unsigned?
  11. FIXED_PREC_SCALE boolean =>can it be a money value?
  12. AUTO_INCREMENT boolean =>can it be used for an auto-increment value?
  13. LOCAL_TYPE_NAME String =>localized version of type name (may be null)
  14. MINIMUM_SCALE short =>minimum scale supported
  15. MAXIMUM_SCALE short =>maximum scale supported
  16. SQL_DATA_TYPE int =>unused
  17. SQL_DATETIME_SUB int =>unused
  18. NUM_PREC_RADIX int =>usually 2 or 10

  Specified by:
    `getTypeInfo` in interface `java.sql.DatabaseMetaData`
  Returns:
    ResultSet - each row is a SQL type description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getUDTs

    public java.sql.ResultSet getUDTs(java.lang.String catalog,
                                      java.lang.String schemaPattern,
                                      java.lang.String typeNamePattern,
                                      int[] types)
                               throws java.sql.SQLException

  JDBC 2.0 Gets a description of the user-defined types defined in a particular schema. Schema-specific UDTs may have type JAVA_OBJECT, STRUCT, or DISTINCT.

  Only types matching the catalog, schema, type name and type criteria are returned. They are ordered by DATA_TYPE, TYPE_SCHEM and TYPE_NAME. The type name parameter may be a fully-qualified name. In this case, the catalog and schemaPattern parameters are ignored.

  Each type description has the following columns:

  1. TYPE_CAT String =>the type's catalog (may be null)
  2. TYPE_SCHEM String =>type's schema (may be null)
  3. TYPE_NAME String =>type name
  4. CLASS_NAME String =>Java class name
  5. DATA_TYPE String =>type value defined in java.sql.Types. One of JAVA_OBJECT, STRUCT, or DISTINCT
  6. REMARKS String =>explanatory comment on the type

  Note: If the driver does not support UDTs, an empty result set is returned.

  Specified by:
    `getUDTs` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `typeNamePattern` - a type name pattern; may be a fully-qualified name
    `types` - a list of user-named types to include (JAVA_OBJECT, STRUCT, or DISTINCT); null returns all types
  Returns:
    ResultSet - each row is a type description
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### getURL

    public java.lang.String getURL()
                            throws java.sql.SQLException

  What's the URL for this database?

  Specified by:
    `getURL` in interface `java.sql.DatabaseMetaData`
  Returns:
    the URL or null if it can't be generated
  Throws:
    `java.sql.SQLException` - if a database-access error occurs

### getUserName

    public java.lang.String getUserName()
                                 throws java.sql.SQLException

  What's our user name as known to the database?

  Specified by:
    `getUserName` in interface `java.sql.DatabaseMetaData`
  Returns:
    our database user name
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getVersionColumns

    public java.sql.ResultSet getVersionColumns(java.lang.String catalog,
                                                java.lang.String schema,
                                                java.lang.String table)
                                         throws java.sql.SQLException

  Get a description of a table's columns that are automatically updated when any value in a row is updated. They are unordered.

  Each column description has the following columns:

  1. SCOPE short =>is not used
  2. COLUMN_NAME String =>column name
  3. DATA_TYPE short =>SQL data type from java.sql.Types
  4. TYPE_NAME String =>Data source dependent type name
  5. COLUMN_SIZE int =>precision
  6. BUFFER_LENGTH int =>length of column value in bytes
  7. DECIMAL_DIGITS short =>scale
  8. PSEUDO_COLUMN short =>is this a pseudo column like an Oracle ROWID
     - versionColumnUnknown - may or may not be pseudo column
     - versionColumnNotPseudo - is NOT a pseudo column
     - versionColumnPseudo - is a pseudo column

  Specified by:
    `getVersionColumns` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a `null` means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    ResultSet - each row is a column description
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### isCatalogAtStart

    public boolean isCatalogAtStart()
                             throws java.sql.SQLException

  Retrieves whether a catalog appears at the start of a fully qualified table name. If not, the catalog appears at the end.

  Specified by:
    `isCatalogAtStart` in interface `java.sql.DatabaseMetaData`
  Returns:
    true if it appears at the start
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### isReadOnly

    public boolean isReadOnly()
                       throws java.sql.SQLException

  Is the database in read-only mode?

  Specified by:
    `isReadOnly` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### getConnection

    public java.sql.Connection getConnection()
                                      throws java.sql.SQLException

  JDBC 2.0 Retrieves the connection that produced this metadata object.

  Specified by:
    `getConnection` in interface `java.sql.DatabaseMetaData`
  Returns:
    the connection that produced this metadata object
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### nullPlusNonNullIsNull

    public boolean nullPlusNonNullIsNull()
                                  throws java.sql.SQLException

  Retrieves whether this database supports concatenations between `NULL` and non-`NULL` values being `NULL`.

  Specified by:
    `nullPlusNonNullIsNull` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### nullsAreSortedAtEnd

    public boolean nullsAreSortedAtEnd()
                                throws java.sql.SQLException

  Are NULL values sorted at the end regardless of sort order?

  Specified by:
    `nullsAreSortedAtEnd` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### nullsAreSortedAtStart

    public boolean nullsAreSortedAtStart()
                                  throws java.sql.SQLException

  Are NULL values sorted at the start regardless of sort order?

  Specified by:
    `nullsAreSortedAtStart` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### nullsAreSortedHigh

    public boolean nullsAreSortedHigh()
                               throws java.sql.SQLException

  Are NULL values sorted high?

  Specified by:
    `nullsAreSortedHigh` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### nullsAreSortedLow

    public boolean nullsAreSortedLow()
                              throws java.sql.SQLException

  Are NULL values sorted low?

  Specified by:
    `nullsAreSortedLow` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### storesLowerCaseIdentifiers

    public boolean storesLowerCaseIdentifiers()
                                       throws java.sql.SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?

  Specified by:
    `storesLowerCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### storesLowerCaseQuotedIdentifiers

    public boolean storesLowerCaseQuotedIdentifiers()
                                             throws java.sql.SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?

  Specified by:
    `storesLowerCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### storesMixedCaseIdentifiers

    public boolean storesMixedCaseIdentifiers()
                                       throws java.sql.SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?

  Specified by:
    `storesMixedCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### storesMixedCaseQuotedIdentifiers

    public boolean storesMixedCaseQuotedIdentifiers()
                                             throws java.sql.SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?

  Specified by:
    `storesMixedCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### storesUpperCaseIdentifiers

    public boolean storesUpperCaseIdentifiers()
                                       throws java.sql.SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?

  Specified by:
    `storesUpperCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### storesUpperCaseQuotedIdentifiers

    public boolean storesUpperCaseQuotedIdentifiers()
                                             throws java.sql.SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?

  Specified by:
    `storesUpperCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsAlterTableWithAddColumn

    public boolean supportsAlterTableWithAddColumn()
                                            throws java.sql.SQLException

  Is "ALTER TABLE" with add column supported?

  Specified by:
    `supportsAlterTableWithAddColumn` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsAlterTableWithDropColumn

    public boolean supportsAlterTableWithDropColumn()
                                             throws java.sql.SQLException

  Is "ALTER TABLE" with drop column supported?

  Specified by:
    `supportsAlterTableWithDropColumn` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsANSI92EntryLevelSQL

    public boolean supportsANSI92EntryLevelSQL()
                                        throws java.sql.SQLException

  Retrieves whether this database supports the ANSI92 entry level SQL grammar.

  Specified by:
    `supportsANSI92EntryLevelSQL` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsANSI92FullSQL

    public boolean supportsANSI92FullSQL()
                                  throws java.sql.SQLException

  Is the ANSI92 full SQL grammar supported?

  Specified by:
    `supportsANSI92FullSQL` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsANSI92IntermediateSQL

    public boolean supportsANSI92IntermediateSQL()
                                          throws java.sql.SQLException

  Is the ANSI92 intermediate SQL grammar supported?

  Specified by:
    `supportsANSI92IntermediateSQL` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsCatalogsInDataManipulation

    public boolean supportsCatalogsInDataManipulation()
                                               throws java.sql.SQLException

  Can a catalog name be used in a data manipulation statement?

  Specified by:
    `supportsCatalogsInDataManipulation` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsCatalogsInIndexDefinitions

    public boolean supportsCatalogsInIndexDefinitions()
                                               throws java.sql.SQLException

  Can a catalog name be used in an index definition statement?

  Specified by:
    `supportsCatalogsInIndexDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsCatalogsInPrivilegeDefinitions

    public boolean supportsCatalogsInPrivilegeDefinitions()
                                                   throws java.sql.SQLException

  Can a catalog name be used in a privilege definition statement?

  Specified by:
    `supportsCatalogsInPrivilegeDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsCatalogsInProcedureCalls

    public boolean supportsCatalogsInProcedureCalls()
                                             throws java.sql.SQLException

  Can a catalog name be used in a procedure call statement?

  Specified by:
    `supportsCatalogsInProcedureCalls` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsCatalogsInTableDefinitions

    public boolean supportsCatalogsInTableDefinitions()
                                               throws java.sql.SQLException

  Can a catalog name be used in a table definition statement?

  Specified by:
    `supportsCatalogsInTableDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsColumnAliasing

    public boolean supportsColumnAliasing()
                                   throws java.sql.SQLException

  Retrieves whether this database supports column aliasing.

  If so, the SQL AS clause can be used to provide names for computed columns or to provide alias names for columns as required. A JDBC-Compliant driver always returns true.

  Specified by:
    `supportsColumnAliasing` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsConvert

    public boolean supportsConvert()
                            throws java.sql.SQLException

  Is the CONVERT function between SQL types supported?

  Specified by:
    `supportsConvert` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsConvert

    public boolean supportsConvert(int fromType,
                                   int toType)
                            throws java.sql.SQLException

  Is CONVERT between the given SQL types supported?

  Specified by:
    `supportsConvert` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `fromType` - the type to convert from
    `toType` - the type to convert to
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsCoreSQLGrammar

    public boolean supportsCoreSQLGrammar()
                                   throws java.sql.SQLException

  Is the ODBC Core SQL grammar supported?

  Specified by:
    `supportsCoreSQLGrammar` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsCorrelatedSubqueries

    public boolean supportsCorrelatedSubqueries()
                                         throws java.sql.SQLException

  Retrieves whether this database supports correlated subqueries.

  Specified by:
    `supportsCorrelatedSubqueries` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsDataDefinitionAndDataManipulationTransactions

    public boolean supportsDataDefinitionAndDataManipulationTransactions()
                                                                  throws java.sql.SQLException

  Are both data definition and data manipulation statements within a transaction supported?

  Specified by:
    `supportsDataDefinitionAndDataManipulationTransactions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsDataManipulationTransactionsOnly

    public boolean supportsDataManipulationTransactionsOnly()
                                                     throws java.sql.SQLException

  Are only data manipulation statements within a transaction supported?

  Specified by:
    `supportsDataManipulationTransactionsOnly` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsDifferentTableCorrelationNames

    public boolean supportsDifferentTableCorrelationNames()
                                                   throws java.sql.SQLException

  If table correlation names are supported, are they restricted to be different from the names of the tables?

  Specified by:
    `supportsDifferentTableCorrelationNames` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsExpressionsInOrderBy

    public boolean supportsExpressionsInOrderBy()
                                         throws java.sql.SQLException

  Are expressions in "ORDER BY" lists supported?

  Specified by:
    `supportsExpressionsInOrderBy` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsExtendedSQLGrammar

    public boolean supportsExtendedSQLGrammar()
                                       throws java.sql.SQLException

  Is the ODBC Extended SQL grammar supported?

  Specified by:
    `supportsExtendedSQLGrammar` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsFullOuterJoins

    public boolean supportsFullOuterJoins()
                                   throws java.sql.SQLException

  Are full nested outer joins supported?

  Specified by:
    `supportsFullOuterJoins` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsGroupBy

    public boolean supportsGroupBy()
                            throws java.sql.SQLException

  Is some form of "GROUP BY" clause supported?

  Specified by:
    `supportsGroupBy` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsGroupByBeyondSelect

    public boolean supportsGroupByBeyondSelect()
                                        throws java.sql.SQLException

  Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?

  Specified by:
    `supportsGroupByBeyondSelect` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsGroupByUnrelated

    public boolean supportsGroupByUnrelated()
                                     throws java.sql.SQLException

  Can a "GROUP BY" clause use columns not in the SELECT?

  Specified by:
    `supportsGroupByUnrelated` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsIntegrityEnhancementFacility

    public boolean supportsIntegrityEnhancementFacility()
                                                 throws java.sql.SQLException

  Is the SQL Integrity Enhancement Facility supported?

  Specified by:
    `supportsIntegrityEnhancementFacility` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsLikeEscapeClause

    public boolean supportsLikeEscapeClause()
                                     throws java.sql.SQLException

  Retrieves whether this database supports specifying a `LIKE` escape clause.

  Specified by:
    `supportsLikeEscapeClause` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsLimitedOuterJoins

    public boolean supportsLimitedOuterJoins()
                                      throws java.sql.SQLException

  Retrieves whether this database provides limited support for outer joins. (This will be `true` if the method `supportsFullOuterJoins` returns `true`).

  Specified by:
    `supportsLimitedOuterJoins` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsMinimumSQLGrammar

    public boolean supportsMinimumSQLGrammar()
                                      throws java.sql.SQLException

  Retrieves whether this database supports the ODBC Minimum SQL grammar.

  Specified by:
    `supportsMinimumSQLGrammar` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsMixedCaseIdentifiers

    public boolean supportsMixedCaseIdentifiers()
                                         throws java.sql.SQLException

  Retrieves whether this database treats mixed case unquoted SQL identifiers as case sensitive and as a result stores them in mixed case.

  Specified by:
    `supportsMixedCaseIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsMixedCaseQuotedIdentifiers

    public boolean supportsMixedCaseQuotedIdentifiers()
                                               throws java.sql.SQLException

  Retrieves whether this database treats mixed case quoted SQL identifiers as case sensitive and as a result stores them in mixed case.

  Specified by:
    `supportsMixedCaseQuotedIdentifiers` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsMultipleResultSets

    public boolean supportsMultipleResultSets()
                                       throws java.sql.SQLException

  Are multiple ResultSets from a single execute supported?

  Specified by:
    `supportsMultipleResultSets` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsMultipleTransactions

    public boolean supportsMultipleTransactions()
                                         throws java.sql.SQLException

  Can we have multiple transactions open at once (on different connections)?

  Specified by:
    `supportsMultipleTransactions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsNonNullableColumns

    public boolean supportsNonNullableColumns()
                                       throws java.sql.SQLException

  Retrieves whether columns in this database may be defined as non-nullable.

  Specified by:
    `supportsNonNullableColumns` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsOpenCursorsAcrossCommit

    public boolean supportsOpenCursorsAcrossCommit()
                                            throws java.sql.SQLException

  Can cursors remain open across commits?

  Specified by:
    `supportsOpenCursorsAcrossCommit` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsOpenCursorsAcrossRollback

    public boolean supportsOpenCursorsAcrossRollback()
                                              throws java.sql.SQLException

  Can cursors remain open across rollbacks?

  Specified by:
    `supportsOpenCursorsAcrossRollback` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsOpenStatementsAcrossCommit

    public boolean supportsOpenStatementsAcrossCommit()
                                               throws java.sql.SQLException

  Can statements remain open across commits?

  Specified by:
    `supportsOpenStatementsAcrossCommit` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if statements always remain open; `false` if they might not remain open
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsOpenStatementsAcrossRollback

    public boolean supportsOpenStatementsAcrossRollback()
                                                 throws java.sql.SQLException

  Can statements remain open across rollbacks?

  Specified by:
    `supportsOpenStatementsAcrossRollback` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if statements always remain open; `false` if they might not remain open
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsOrderByUnrelated

    public boolean supportsOrderByUnrelated()
                                     throws java.sql.SQLException

  Can an "ORDER BY" clause use columns not in the SELECT?

  Specified by:
    `supportsOrderByUnrelated` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsOuterJoins

    public boolean supportsOuterJoins()
                               throws java.sql.SQLException

  Is some form of outer join supported?

  Specified by:
    `supportsOuterJoins` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsPositionedDelete

    public boolean supportsPositionedDelete()
                                     throws java.sql.SQLException

  Is positioned DELETE supported?

  Specified by:
    `supportsPositionedDelete` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsPositionedUpdate

    public boolean supportsPositionedUpdate()
                                     throws java.sql.SQLException

  Is positioned UPDATE supported?

  Specified by:
    `supportsPositionedUpdate` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsSchemasInDataManipulation

    public boolean supportsSchemasInDataManipulation()
                                              throws java.sql.SQLException

  Can a schema name be used in a data manipulation statement?

  Specified by:
    `supportsSchemasInDataManipulation` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsSchemasInIndexDefinitions

    public boolean supportsSchemasInIndexDefinitions()
                                              throws java.sql.SQLException

  Can a schema name be used in an index definition statement?

  Specified by:
    `supportsSchemasInIndexDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsSchemasInPrivilegeDefinitions

    public boolean supportsSchemasInPrivilegeDefinitions()
                                                  throws java.sql.SQLException

  Can a schema name be used in a privilege definition statement?

  Specified by:
    `supportsSchemasInPrivilegeDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsSchemasInProcedureCalls

    public boolean supportsSchemasInProcedureCalls()
                                            throws java.sql.SQLException

  Can a schema name be used in a procedure call statement?

  Specified by:
    `supportsSchemasInProcedureCalls` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsSchemasInTableDefinitions

    public boolean supportsSchemasInTableDefinitions()
                                              throws java.sql.SQLException

  Can a schema name be used in a table definition statement?

  Specified by:
    `supportsSchemasInTableDefinitions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsSelectForUpdate

    public boolean supportsSelectForUpdate()
                                    throws java.sql.SQLException

  Is SELECT for UPDATE supported?

  Specified by:
    `supportsSelectForUpdate` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsStoredProcedures

    public boolean supportsStoredProcedures()
                                     throws java.sql.SQLException

  Are stored procedure calls using the stored procedure escape syntax supported?

  Specified by:
    `supportsStoredProcedures` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsSubqueriesInComparisons

    public boolean supportsSubqueriesInComparisons()
                                            throws java.sql.SQLException

  Retrieves whether this database supports subqueries in comparison expressions.

  Specified by:
    `supportsSubqueriesInComparisons` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsSubqueriesInExists

    public boolean supportsSubqueriesInExists()
                                       throws java.sql.SQLException

  Retrieves whether this database supports subqueries in `EXISTS` expressions.

  Specified by:
    `supportsSubqueriesInExists` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsSubqueriesInIns

    public boolean supportsSubqueriesInIns()
                                    throws java.sql.SQLException

  Retrieves whether this database supports subqueries in `IN` statements.

  Specified by:
    `supportsSubqueriesInIns` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsSubqueriesInQuantifieds

    public boolean supportsSubqueriesInQuantifieds()
                                            throws java.sql.SQLException

  Retrieves whether this database supports subqueries in quantified expressions.

  Specified by:
    `supportsSubqueriesInQuantifieds` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsTableCorrelationNames

    public boolean supportsTableCorrelationNames()
                                          throws java.sql.SQLException

  Retrieves whether this database supports table correlation names.

  Specified by:
    `supportsTableCorrelationNames` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsTransactionIsolationLevel

    public boolean supportsTransactionIsolationLevel(int level)
                                              throws java.sql.SQLException

  Does the database support the given transaction isolation level?

  Specified by:
    `supportsTransactionIsolationLevel` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `level` - the values are defined in java.sql.Connection
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.
  See Also:
    `Connection`

### supportsTransactions

    public boolean supportsTransactions()
                                 throws java.sql.SQLException

  Retrieves whether this database supports transactions. If not, invoking the method `commit` is a noop, and the isolation level is `TRANSACTION_NONE`.

  Specified by:
    `supportsTransactions` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if transactions are supported
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsUnion

    public boolean supportsUnion()
                          throws java.sql.SQLException

  Is SQL UNION supported?

  Specified by:
    `supportsUnion` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsUnionAll

    public boolean supportsUnionAll()
                             throws java.sql.SQLException

  Is SQL UNION ALL supported?

  Specified by:
    `supportsUnionAll` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### usesLocalFilePerTable

    public boolean usesLocalFilePerTable()
                                  throws java.sql.SQLException

  Does the database use a file for each table?

  Specified by:
    `usesLocalFilePerTable` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if the database uses a local file for each table
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### usesLocalFiles

    public boolean usesLocalFiles()
                           throws java.sql.SQLException

  Does the database store tables in a local file?

  Specified by:
    `usesLocalFiles` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if so
  Throws:
    `java.sql.SQLException` - if a database-access error occurs.

### supportsResultSetType

    public boolean supportsResultSetType(int type)
                                  throws java.sql.SQLException

  Does the database support the given result set type?

  Supported types for SQL Server:

  JDBC type | SQL Server cursor type | Server load | Description
  TYPE_FORWARD_ONLY | Forward-only, dynamic (fast forward-only, static with `useCursors=true`) | Light | Fast, will read all data (less fast, doesn't read all data with `useCursors=true`). Forward only.
  TYPE_SCROLL_INSENSITIVE | Static cursor | Heavy | Only use with CONCUR_READ_ONLY. SQL Server generates a temporary table, so changes made by others are not visible. Scrollable.
  TYPE_SCROLL_SENSITIVE | Keyset cursor | Medium | Others' updates or deletes visible, but not others' inserts. Scrollable.
  TYPE_SCROLL_SENSITIVE + 1 | Dynamic cursor | Heavy | Others' updates, deletes and inserts visible. Scrollable.

  Specified by:
    `supportsResultSetType` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `Connection`, `supportsResultSetConcurrency(int, int)`

### supportsResultSetConcurrency

    public boolean supportsResultSetConcurrency(int type,
                                                int concurrency)
                                         throws java.sql.SQLException

  Does the database support the concurrency type in combination with the given result set type?

  Supported concurrencies for SQL Server:

  JDBC concurrency | SQL Server concurrency | Row locks | Description
  CONCUR_READ_ONLY | Read only | No | Read-only.
  CONCUR_UPDATABLE | Optimistic concurrency, updatable | No | Row integrity checked with timestamp comparison or, when not available, value comparison (except text and image fields).
  CONCUR_UPDATABLE+1 | Pessimistic concurrency, updatable | Yes | Row integrity is ensured by locking rows.
  CONCUR_UPDATABLE+2 | Optimistic concurrency, updatable | No | Row integrity checked with value comparison (except text and image fields).

  Specified by:
    `supportsResultSetConcurrency` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - defined in `java.sql.ResultSet`
    `concurrency` - type defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs
  See Also:
    `Connection`, `supportsResultSetType(int)`

### ownUpdatesAreVisible

    public boolean ownUpdatesAreVisible(int type)
                                 throws java.sql.SQLException

  JDBC 2.0 Indicates whether a result set's own updates are visible.

  Specified by:
    `ownUpdatesAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - `ResultSet` type
  Returns:
    `true` if updates are visible for the result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### ownDeletesAreVisible

    public boolean ownDeletesAreVisible(int type)
                                 throws java.sql.SQLException

  JDBC 2.0 Indicates whether a result set's own deletes are visible.

  Specified by:
    `ownDeletesAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - `ResultSet` type
  Returns:
    `true` if deletes are visible for the result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### ownInsertsAreVisible

    public boolean ownInsertsAreVisible(int type)
                                 throws java.sql.SQLException

  JDBC 2.0 Indicates whether a result set's own inserts are visible.

  Specified by:
    `ownInsertsAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - `ResultSet` type
  Returns:
    `true` if inserts are visible for the result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### othersUpdatesAreVisible

    public boolean othersUpdatesAreVisible(int type)
                                    throws java.sql.SQLException

  JDBC 2.0 Indicates whether updates made by others are visible.

  Specified by:
    `othersUpdatesAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - `ResultSet` type
  Returns:
    `true` if updates made by others are visible for the result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### othersDeletesAreVisible

    public boolean othersDeletesAreVisible(int type)
                                    throws java.sql.SQLException

  JDBC 2.0 Indicates whether deletes made by others are visible.

  Specified by:
    `othersDeletesAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - `ResultSet` type
  Returns:
    `true` if deletes made by others are visible for the result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### othersInsertsAreVisible

    public boolean othersInsertsAreVisible(int type)
                                    throws java.sql.SQLException

  JDBC 2.0 Indicates whether inserts made by others are visible.

  Specified by:
    `othersInsertsAreVisible` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - `ResultSet` type
  Returns:
    `true` if inserts made by others are visible for the result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### updatesAreDetected

    public boolean updatesAreDetected(int type)
                               throws java.sql.SQLException

  JDBC 2.0 Indicates whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated` .

  Specified by:
    `updatesAreDetected` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - `ResultSet` type
  Returns:
    `true` if changes are detected by the result set type; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### deletesAreDetected

    public boolean deletesAreDetected(int type)
                               throws java.sql.SQLException

  JDBC 2.0 Indicates whether or not a visible row delete can be detected by calling ResultSet.rowDeleted(). If deletesAreDetected() returns false, then deleted rows are removed from the result set.

  Specified by:
    `deletesAreDetected` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - `ResultSet` type
  Returns:
    `true` if changes are detected by the result set type
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### insertsAreDetected

    public boolean insertsAreDetected(int type)
                               throws java.sql.SQLException

  JDBC 2.0 Indicates whether or not a visible row insert can be detected by calling ResultSet.rowInserted().

  Specified by:
    `insertsAreDetected` in interface `java.sql.DatabaseMetaData`
  Parameters:
    `type` - `ResultSet` type
  Returns:
    `true` if changes are detected by the result set type
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### supportsBatchUpdates

    public boolean supportsBatchUpdates()
                                 throws java.sql.SQLException

  JDBC 2.0 Indicates whether the driver supports batch updates.

  Specified by:
    `supportsBatchUpdates` in interface `java.sql.DatabaseMetaData`
  Returns:
    `true` if the driver supports batch updates; `false` otherwise
  Throws:
    `java.sql.SQLException` - if a database access error occurs

### setCaseSensitiveFlag

    private void setCaseSensitiveFlag()
                               throws java.sql.SQLException

  Throws:
    `java.sql.SQLException`

### getAttributes

    public java.sql.ResultSet getAttributes(java.lang.String catalog,
                                            java.lang.String schemaPattern,
                                            java.lang.String typeNamePattern,
                                            java.lang.String attributeNamePattern)
                                     throws java.sql.SQLException

  Specified by:
    `getAttributes` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### getDatabaseMajorVersion

    public int getDatabaseMajorVersion()
                                throws java.sql.SQLException

  Returns the database major version.

  Specified by:
    `getDatabaseMajorVersion` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### getDatabaseMinorVersion

    public int getDatabaseMinorVersion()
                                throws java.sql.SQLException

  Returns the database minor version.

  Specified by:
    `getDatabaseMinorVersion` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### getJDBCMajorVersion

    public int getJDBCMajorVersion()
                            throws java.sql.SQLException

  Returns the JDBC major version.

  Specified by:
    `getJDBCMajorVersion` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### getJDBCMinorVersion

    public int getJDBCMinorVersion()
                            throws java.sql.SQLException

  Returns the JDBC minor version.

  Specified by:
    `getJDBCMinorVersion` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### getResultSetHoldability

    public int getResultSetHoldability()
                                throws java.sql.SQLException

  Specified by:
    `getResultSetHoldability` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### getSQLStateType

    public int getSQLStateType()
                        throws java.sql.SQLException

  Specified by:
    `getSQLStateType` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### getSuperTables

    public java.sql.ResultSet getSuperTables(java.lang.String catalog,
                                             java.lang.String schemaPattern,
                                             java.lang.String tableNamePattern)
                                      throws java.sql.SQLException

  Specified by:
    `getSuperTables` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### getSuperTypes

    public java.sql.ResultSet getSuperTypes(java.lang.String catalog,
                                            java.lang.String schemaPattern,
                                            java.lang.String typeNamePattern)
                                     throws java.sql.SQLException

  Specified by:
    `getSuperTypes` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### locatorsUpdateCopy

    public boolean locatorsUpdateCopy()
                               throws java.sql.SQLException

  Returns `true` if updates are made to a copy of the LOB; returns `false` if LOB updates are made directly to the database.

  NOTE: Since SQL Server / Sybase do not support LOB locators as Oracle does (AFAIK); this method always returns `true`.

  Specified by:
    `locatorsUpdateCopy` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### supportsGetGeneratedKeys

    public boolean supportsGetGeneratedKeys()
                                     throws java.sql.SQLException

  Returns `true` if getting auto-generated keys is supported after a statment is executed; returns `false` otherwise

  Specified by:
    `supportsGetGeneratedKeys` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### supportsMultipleOpenResults

    public boolean supportsMultipleOpenResults()
                                        throws java.sql.SQLException

  Returns `true` if Callable statements can return multiple result sets; returns `false` if they can only return one result set.

  Specified by:
    `supportsMultipleOpenResults` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### supportsNamedParameters

    public boolean supportsNamedParameters()
                                    throws java.sql.SQLException

  Returns `true` if the database supports named parameters; returns `false` if the database does not support named parameters.

  Specified by:
    `supportsNamedParameters` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### supportsResultSetHoldability

    public boolean supportsResultSetHoldability(int param)
                                         throws java.sql.SQLException

  Specified by:
    `supportsResultSetHoldability` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### supportsSavepoints

    public boolean supportsSavepoints()
                               throws java.sql.SQLException

  Returns `true` if savepoints are supported; returns `false` otherwise

  Specified by:
    `supportsSavepoints` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### supportsStatementPooling

    public boolean supportsStatementPooling()
                                     throws java.sql.SQLException

  Returns `true` if the database supports statement pooling; returns `false` otherwise.

  Specified by:
    `supportsStatementPooling` in interface `java.sql.DatabaseMetaData`
  Throws:
    `java.sql.SQLException`

### processEscapes

    private static java.lang.String processEscapes(java.lang.String pattern)

  Format the supplied search pattern to transform the escape \x into [x].

  Parameters:
    `pattern` - the pattern to tranform
  Returns:
    the transformed pattern as a `String`

### syscall

    private java.lang.String syscall(java.lang.String catalog,
                                     java.lang.String call)

  Format the supplied procedure call as a valid JDBC call escape.

  Parameters:
    `catalog` - the database name or null
    `call` - the stored procedure call to format
  Returns:
    the formatted call escape as a `String`

### upperCaseColumnNames

    private static void upperCaseColumnNames(JtdsResultSet results)
                                      throws java.sql.SQLException

  Uppercase all column names.

  Sybase returns column names in lowecase while the JDBC standard suggests they should be uppercase.

  Parameters:
    `results` - the result set to modify
  Throws:
    `java.sql.SQLException`

### createTypeInfoResultSet

    private static CachedResultSet createTypeInfoResultSet(JtdsResultSet rs,
                                                           boolean useLOBs)
                                                    throws java.sql.SQLException

  Throws:
    `java.sql.SQLException`

### getSortedTypes

    private static java.util.Collection getSortedTypes(java.sql.ResultSet rs,
                                                       boolean useLOBs)
                                                throws java.sql.SQLException

  Throws:
    `java.sql.SQLException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Generated on December 30 2009